## GimpController GimpController — Pluggable GIMP input controller modules. |

## Functions

GimpController * | gimp_controller_new ()
gint | gimp_controller_get_n_events ()
const gchar * | gimp_controller_get_event_name ()
const gchar * | gimp_controller_get_event_blurb ()
gboolean | gimp_controller_event ()

## Properties

gchar * | name | Read / Write / Construct
gchar * | state | Read / Write / Construct

## Signals

gboolean | event | Run Last

## Types and Values

enum | GimpControllerEventType
struct | GimpControllerEventAny
struct | GimpControllerEventTrigger
struct | GimpControllerEventValue
union | GimpControllerEvent
| GimpController

## Object Hierarchy

        GObject
        ╰── GimpController

## Implemented Interfaces

GimpController implements GimpConfigInterface.

## Description

An abstract interface for implementing arbitrary input controllers.

## Functions

### gimp_controller_new ()

    GimpController *
    gimp_controller_new (GType controller_type);

#### Returns

### gimp_controller_get_n_events ()

    gint
    gimp_controller_get_n_events (GimpController *controller);

#### Returns

### gimp_controller_get_event_name ()

    const gchar *
    gimp_controller_get_event_name (GimpController *controller,
                                    gint event_id);

#### Returns

### gimp_controller_get_event_blurb ()

    const gchar *
    gimp_controller_get_event_blurb (GimpController *controller,
                                     gint event_id);

#### Returns

### gimp_controller_event ()

    gboolean
    gimp_controller_event (GimpController *controller,
                           const GimpControllerEvent *event);

#### Returns

## Types and Values

### enum GimpControllerEventType

Event types for GimpController.

#### Members

GIMP_CONTROLLER_EVENT_TRIGGER | the event is a simple trigger |
GIMP_CONTROLLER_EVENT_VALUE | the event carries a double value |

### struct GimpControllerEventAny

    struct GimpControllerEventAny {
      GimpControllerEventType  type;
      GimpController          *source;
      gint                     event_id;
    };

### struct GimpControllerEventTrigger

    struct GimpControllerEventTrigger {
      GimpControllerEventType  type;
      GimpController          *source;
      gint                     event_id;
    };

### struct GimpControllerEventValue

    struct GimpControllerEventValue {
      GimpControllerEventType  type;
      GimpController          *source;
      gint                     event_id;
      GValue                   value;
    };

### union GimpControllerEvent

### GimpController

    typedef struct _GimpController GimpController;

## Property Details

### The `“name”` property

      “name”                     gchar *

Flags: Read / Write / Construct

Default value: "Unnamed Controller"

### The `“state”` property

      “state”                    gchar *

Flags: Read / Write / Construct

Default value: "Unknown"

## Signal Details

### The `“event”` signal

    gboolean
    user_function (GimpController *gimpcontroller,
                   gpointer        arg1,
                   gpointer        user_data)

#### Parameters

gimpcontroller | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

#### Returns

Flags: Run Last